;;; Sierra Script 1.0 - (do not remove this comment)
(script# 994)
(include game.sh)
(use Main)
(use Print)
(use Polygon)
(use Sound)
(use Save)
(use Motion)
(use Invent)
(use User)
(use System)


(procedure (localproc_0e32 param1 &tmp temp0 [temp1 40] [temp41 40] temp81 [temp82 40] [temp122 10] [temp132 5])
	(= temp81 (Memory MNeedPtr 150))
	(= temp0 1)
	(DeviceInfo 0 curSaveDir @temp1)
	(DeviceInfo 1 @temp41)
	(if
		(and
			(DeviceInfo 3 @temp41)
			(or
				(DeviceInfo 2 @temp1 @temp41)
				(not (DeviceInfo 6 (theGame name?)))
			)
		)
		(Message msgGET 994 6 0 0 1 @temp82)
		(Message msgGET 994 7 0 0 1 @temp122)
		(Message msgGET 994 8 0 0 1 @temp132)
		(Format
			temp81
			@temp82
			(if param1 @temp122 else @temp132)
			@temp1
		)
		(Load RES_FONT userFont)
		(DeviceInfo 4)
		(Message msgGET 994 2 0 0 1 @temp82)
		(Message msgGET 994 4 0 0 1 @temp122)
		(Message msgGET 994 5 0 0 1 @temp132)
		(if
			(==
				(= temp0
					(if param1
						(Print
							font: 0
							addText: temp81
							addButton: 1 @temp82 0 40
							addButton: 0 @temp122 30 40
							addButton: 2 @temp132
							init:
						)
					else
						(Print
							font: 0
							addText: temp81
							addButton: 1 @temp82 0 40
							init:
						)
					)
				)
				2
			)
			(= temp0 (GetDirectory curSaveDir))
		)
	)
	(Memory MDisposePtr temp81)
	(return temp0)
)

(instance theCast of EventHandler
	(properties
		name "cast"
	)
)

(instance theFeatures of EventHandler
	(properties
		name "features"
	)
)

(instance demons of EventHandler
	(properties
		name "theDoits"
	)
)

(class Sounds of EventHandler
	(properties
		elements 0
		size 0
	)
	
	(method (pause param1)
		(self
			eachElementDo: #perform mayPause (if argc param1 else 1)
		)
	)
)

(instance mayPause of Code
	(properties)
	
	(method (doit param1 param2)
		(if (not (& (param1 flags?) $0001))
			(param1 pause: param2)
		)
	)
)

(instance theRegions of EventHandler
	(properties
		name "regions"
	)
)

(instance theAddToPics of EventHandler
	(properties
		name "addToPics"
	)
	
	(method (doit)
		(self eachElementDo: #perform addToObstaclesCode)
		(AddToPic elements)
	)
)

(instance theTimers of Set
	(properties
		name "timers"
	)
)

(instance theMouseDownHandler of EventHandler
	(properties
		name "mouseDownHandler"
	)
)

(instance theKeyDownHandler of EventHandler
	(properties
		name "keyDownHandler"
	)
)

(instance theDirectionHandler of EventHandler
	(properties
		name "directionHandler"
	)
)

(instance theWalkHandler of EventHandler
	(properties
		name "walkHandler"
	)
)

(class Cue of Object
	(properties
		cuee 0
		cuer 0
		register 0
	)
	
	(method (doit)
		(cuees delete: self)
		(if (cuees isEmpty:) (cuees dispose:) (= cuees 0))
		(cuee cue: register cuer)
		(self dispose:)
	)
)

(instance addToObstaclesCode of Code
	(properties
		name "aTOC"
	)
	
	(method (doit param1 &tmp temp0 temp1)
		(if (not (& (param1 signal?) $4000))
			(= temp0
				(+ (ego xStep?) (/ (CelWide (ego view?) 2 0) 2))
			)
			(= temp1 (* (ego yStep?) 2))
			(curRoom
				addObstacle:
					((Polygon new:)
						init:
							(- (param1 brLeft?) temp0)
							(- (CoordPri 1 (CoordPri (param1 y?))) temp1)
							(+ (param1 brRight?) temp0)
							(- (CoordPri 1 (CoordPri (param1 y?))) temp1)
							(+ (param1 brRight?) temp0)
							(+ (param1 y?) temp1)
							(- (param1 brLeft?) temp0)
							(+ (param1 y?) temp1)
						yourself:
					)
			)
		)
	)
)

(class Game of Object
	(properties
		script 0
		printLang 1
		_detailLevel 3
		panelObj 0
		panelSelector 0
		handsOffCode 0
		handsOnCode 0
	)
	
	(method (init)
		Motion
		Sound
		((= cast theCast) add:)
		((= features theFeatures) add:)
		((= sounds Sounds) add:)
		((= regions theRegions) add:)
		((= addToPics theAddToPics) add:)
		((= timers theTimers) add:)
		((= theDoits demons) add:)
		((= mouseDownHandler theMouseDownHandler) add:)
		((= keyDownHandler theKeyDownHandler) add:)
		((= directionHandler theDirectionHandler) add:)
		((= walkHandler theWalkHandler) add:)
		(= fastCast 0)
		(= curSaveDir (GetSaveDir))
		(Inventory init:)
		(if (not user) (= user User))
		(user init:)
	)
	
	(method (doit &tmp newEvent thePanelObj thePanelSelector)
		(if panelObj
			(= thePanelObj panelObj)
			(= thePanelSelector panelSelector)
			(= panelObj (= panelSelector 0))
			(Eval thePanelObj thePanelSelector)
		)
		(= gameTime (+ tickOffset (GetTime)))
		(if fastCast
			(while fastCast
				(fastCast eachElementDo: #doit)
				(if
				(and ((= newEvent (Event new:)) type?) fastCast)
					(fastCast firstTrue: #handleEvent newEvent)
				)
				(newEvent dispose:)
				(= gameTime (+ tickOffset (GetTime)))
				(sounds eachElementDo: #check)
			)
		)
		(if prints
			(prints eachElementDo: #doit)
			(if (not modelessDialog)
				(if
				(and ((= newEvent (Event new:)) type?) prints)
					(prints firstTrue: #handleEvent newEvent)
				)
				(newEvent dispose:)
				(= gameTime (+ tickOffset (GetTime)))
				(return)
			)
		)
		(sounds eachElementDo: #check)
		(timers eachElementDo: #doit)
		(if (and modelessDialog (modelessDialog check:))
			(modelessDialog dispose:)
		)
		(Animate (cast elements?) 1)
		(if doMotionCue
			(= doMotionCue 0)
			(cast eachElementDo: #motionCue)
		)
		(if cuees (cuees eachElementDo: #doit))
		(if script (script doit:))
		(regions eachElementDo: #doit)
		(if fastCast (return))
		(if (== newRoomNum curRoomNum) (user doit:))
		(theDoits doit:)
		(if (!= newRoomNum curRoomNum)
			(self newRoom: newRoomNum)
		)
		(timers eachElementDo: #delete)
		(GameIsRestarting 0)
	)
	
	(method (play)
		(= theGame self)
		(= curSaveDir (GetSaveDir))
		(self setCursor: waitCursor 1 init:)
		(self setCursor: normalCursor 1)
		(while (not quit)
			(self doit:)
		)
	)
	
	(method (replay &tmp temp0)
		(if lastEvent (lastEvent dispose:))
		(if modelessDialog (modelessDialog dispose:))
		(cast eachElementDo: #perform RestoreUpdate)
		(theGame setCursor: waitCursor 1)
		(= temp0
			(if (not (OneOf (curRoom style?) -1 11 12 13 14))
				(curRoom style?)
			else
				100
			)
		)
		(DrawPic (curRoom curPic?) temp0 dpCLEAR)
		(if (!= overlays -1)
			(DrawPic overlays dpOPEN_NO_TRANSITION dpNO_CLEAR)
		)
		(addToPics doit:)
		(cond 
			(
			(and (not (user canControl:)) (not (user canInput:))) (theGame setCursor: waitCursor))
			((and theIconBar (theIconBar curIcon?)) (theGame setCursor: ((theIconBar curIcon?) cursor?)))
			(else (theGame setCursor: normalCursor))
		)
		(StatusLine doit:)
		(DoSound RestoreSound)
		(sounds pause: 0)
		(= tickOffset (- gameTime (GetTime)))
		(while (not quit)
			(self doit:)
		)
	)
	
	(method (newRoom newRoomNumber &tmp [temp0 5] temp5)
		(addToPics
			eachElementDo: #dispose
			eachElementDo: #delete
			release:
		)
		(features eachElementDo: #perform featureDisposeCode release:)
		(cast eachElementDo: #dispose eachElementDo: #delete)
		(timers eachElementDo: #delete)
		(regions eachElementDo: #perform DisposeNonKeptRegion release:)
		(theDoits release:)
		(Animate 0)
		(= prevRoomNum curRoomNum)
		(= curRoomNum newRoomNumber)
		(= newRoomNum newRoomNumber)
		(FlushResources newRoomNumber)
		(self startRoom: curRoomNum)
		(while ((= temp5 (Event new: 3)) type?)
			(temp5 dispose:)
		)
		(temp5 dispose:)
	)
	
	(method (startRoom param1)
		(if debugOn (SetDebug))
		(regions addToFront: (= curRoom (ScriptID param1)))
		(curRoom init:)
	)
	
	(method (restart)
		(if modelessDialog (modelessDialog dispose:))
		(RestartGame)
	)
	
	(method (restore &tmp [temp0 20] temp20 temp21 [temp22 100] [temp122 5] [temp127 100])
		(if (not (ValidPath curSaveDir))
			(Message msgGET 994 9 0 0 1 @temp22)
			(Format @temp127 @temp22 curSaveDir)
			(Print font: 0 addText: @temp127 init:)
			(GetDirectory curSaveDir)
		)
		(Load RES_FONT smallFont)
		(ScriptID 990)
		(= temp21 (self setCursor: normalCursor))
		(sounds pause: 1)
		(if (localproc_0e32 1)
			(if modelessDialog (modelessDialog dispose:))
			(if (!= (= temp20 (Restore doit: &rest)) -1)
				(self setCursor: waitCursor 1)
				(if (CheckSaveGame name temp20 version)
					(RestoreGame name temp20 version)
				else
					(Message msgGET 994 3 0 0 1 @temp22)
					(Message msgGET 994 2 0 0 1 @temp122)
					(Print
						font: 0
						addText: @temp22
						addButton: 1 @temp122 0 40
						init:
					)
					(self setCursor: temp21 (HaveMouse))
				)
			)
			(localproc_0e32 0)
		)
		(sounds pause: 0)
	)
	
	(method (save &tmp [temp0 20] temp20 temp21 [temp22 100] [temp122 5] [temp127 100])
		(if (not (ValidPath curSaveDir))
			(Message msgGET 994 9 0 0 1 @temp22)
			(Format @temp127 @temp22 curSaveDir)
			(Print font: 0 addText: @temp127 init:)
			(GetDirectory curSaveDir)
		)
		(Load RES_FONT smallFont)
		(ScriptID 990)
		(= temp21 (self setCursor: normalCursor))
		(sounds pause: 1)
		(if (localproc_0e32 1)
			(if modelessDialog (modelessDialog dispose:))
			(if (!= (= temp20 (Save doit: @temp0)) -1)
				(= temp21 (self setCursor: waitCursor 1))
				(if (not (SaveGame name temp20 @temp0 version))
					(Message msgGET 994 1 0 0 1 @temp22)
					(Message msgGET 994 2 0 0 1 @temp122)
					(Print
						font: 0
						addText: @temp22
						addButton: 1 @temp122 0 40
						init:
					)
				)
				(self setCursor: temp21 (HaveMouse))
			)
			(localproc_0e32 0)
		)
		(sounds pause: 0)
	)
	
	(method (changeScore param1)
		(= score (+ score param1))
		(StatusLine doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((pEvent claimed?) 1)
			((and script (script handleEvent: pEvent)) 1)
			((& (pEvent type?) evVERB) (self pragmaFail:))
		)
		(pEvent claimed?)
	)
	
	(method (showMem &tmp [temp0 100])
		(Format
			@temp0
			{Free Heap: %u Bytes\nLargest ptr: %u Bytes\nFreeHunk: %u KBytes\nLargest hunk: %u Bytes}
			(MemoryInfo 1)
			(MemoryInfo 0)
			(>> (MemoryInfo 3) $0006)
			(MemoryInfo 2)
		)
		(Print addText: @temp0 init:)
	)
	
	(method (setCursor cursorNumber param2 param3 param4 param5 param6 &tmp theTheCursor)
		(= theTheCursor theCursor)
		(if (IsObject cursorNumber)
			(= theCursor cursorNumber)
			(cursorNumber init:)
		else
			(SetCursor cursorNumber 0 0)
		)
		(if (> argc 1)
			(SetCursor param2)
			(if (> argc 2)
				(SetCursor param3 param4)
				(if (> argc 4)
					(SetCursor cursorNumber 0 0 param5 param6)
				)
			)
		)
		(return theTheCursor)
	)
	
	(method (notify)
	)
	
	(method (setScript theScript)
		(if script (script dispose:))
		(if theScript (theScript init: self &rest))
	)
	
	(method (cue)
		(if script (script cue:))
	)
	
	(method (quitGame param1)
		(if (or (not argc) param1) (= quit 1))
	)
	
	(method (masterVolume param1)
		(if argc
			(DoSound MasterVol param1)
		else
			(DoSound MasterVol)
		)
	)
	
	(method (detailLevel the_detailLevel)
		(if argc
			(= _detailLevel the_detailLevel)
			(cast eachElementDo: #checkDetail)
		)
		(return _detailLevel)
	)
	
	(method (pragmaFail)
	)
	
	(method (handsOff)
		(if handsOffCode
			(handsOffCode doit: &rest)
		else
			(User canControl: 0 canInput: 0)
			(if (IsObject ego) (ego setMotion: 0))
		)
	)
	
	(method (handsOn)
		(if handsOnCode
			(handsOnCode doit: &rest)
		else
			(User canControl: 1 canInput: 1)
		)
	)
)

(class Region of Object
	(properties
		name "Rgn"
		script 0
		number 0
		modNum -1
		noun 0
		timer 0
		keep 0
		initialized 0
	)
	
	(method (init)
		(if (not initialized)
			(= initialized 1)
			(if (not (regions contains: self))
				(regions addToEnd: self)
			)
			(super init:)
		)
	)
	
	(method (doit)
		(if script (script doit:))
	)
	
	(method (dispose)
		(regions delete: self)
		(if (IsObject script) (script dispose:))
		(if (IsObject timer) (timer dispose: delete:))
		(sounds eachElementDo: #clean self)
		(DisposeScript number)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((pEvent claimed?) 1)
			((& (pEvent type?) evJOYSTICK) 0)
			(
				(not
					(if
					(and script (or (script handleEvent: pEvent) 1))
						(pEvent claimed?)
					)
				)
				(pEvent claimed: (self doVerb: (pEvent message?)))
			)
		)
		(pEvent claimed?)
	)
	
	(method (doVerb theVerb &tmp temp0)
		(if (== modNum -1) (= modNum curRoomNum))
		(return
			(if (Message msgGET modNum noun theVerb 0 1)
				(messager say: noun theVerb 0 0 0 modNum)
				1
			else
				0
			)
		)
	)
	
	(method (setScript theScript)
		(if (IsObject script) (script dispose:))
		(if theScript (theScript init: self &rest))
	)
	
	(method (cue)
		(if script (script cue:))
	)
	
	(method (newRoom)
	)
	
	(method (notify)
	)
)

(class Room of Region
	(properties
		name "Rm"
		script 0
		number 0
		modNum -1
		noun 0
		timer 0
		keep 0
		initialized 0
		picture 0
		style $ffff
		horizon 0
		controls 0
		north 0
		east 0
		south 0
		west 0
		curPic 0
		picAngle 0
		vanishingX 160
		vanishingY 0
		obstacles 0
		inset 0
	)
	
	(method (init)
		(= number curRoomNum)
		(= perspective picAngle)
		(if picture (self drawPic: picture))
		(self
			reflectPosn: (user alterEgo?) ((user alterEgo?) edgeHit?)
		)
		((user alterEgo?) edgeHit: 0)
	)
	
	(method (doit &tmp temp0)
		(if script (script doit:))
		(if
			(= temp0
				(self edgeToRoom: ((user alterEgo?) edgeHit?))
			)
			(self newRoom: temp0)
		)
	)
	
	(method (dispose)
		(if obstacles (obstacles dispose:))
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(if (and inset (inset handleEvent: pEvent))
		else
			(super handleEvent: pEvent)
		)
		(pEvent claimed?)
	)
	
	(method (newRoom newRoomNumber)
		(regions
			delete: self
			eachElementDo: #newRoom newRoomNumber
			addToFront: self
		)
		(= newRoomNum newRoomNumber)
		(super newRoom: newRoomNumber)
	)
	
	(method (setRegions scriptNumbers &tmp temp0 theScriptNumbers temp2)
		(= temp0 0)
		(while (< temp0 argc)
			(= theScriptNumbers [scriptNumbers temp0])
			((= temp2 (ScriptID theScriptNumbers))
				number: theScriptNumbers
			)
			(regions add: temp2)
			(if (not (temp2 initialized?)) (temp2 init:))
			(++ temp0)
		)
	)
	
	(method (drawPic picNumber picAnimation)
		(if addToPics
			(addToPics eachElementDo: #dispose release:)
		)
		(= curPic picNumber)
		(= overlays -1)
		(DrawPic
			picNumber
			(cond 
				((== argc 2) picAnimation)
				((!= style -1) style)
				(else 100)
			)
			dpCLEAR
		)
	)
	
	(method (overlay picNumber picAnimation)
		(= overlays picNumber)
		(DrawPic
			picNumber
			(cond 
				((== argc 2) picAnimation)
				((!= style -1) style)
				(else 100)
			)
			dpNO_CLEAR
		)
	)
	
	(method (addObstacle param1)
		(if (not (IsObject obstacles))
			(= obstacles (List new:))
		)
		(obstacles add: param1 &rest)
	)
	
	(method (reflectPosn param1 param2)
		(switch param2
			(1 (param1 y: 188))
			(4
				(param1 x: (- 319 (param1 xStep?)))
			)
			(3
				(param1 y: (+ horizon (param1 yStep?)))
			)
			(2 (param1 x: 1))
		)
	)
	
	(method (edgeToRoom param1)
		(switch param1
			(1 north)
			(2 east)
			(3 south)
			(4 west)
		)
	)
	
	(method (roomToEdge param1)
		(switch param1
			(north 1)
			(south 3)
			(east 2)
			(west 4)
		)
	)
	
	(method (setInset param1 param2 param3)
		(if inset (inset dispose:))
		(if (and argc param1)
			(param1
				init:
					(if (>= argc 2) param2 else 0)
					self
					(if (>= argc 3) param3 else 0)
			)
		)
	)
)

(class StatusLine of Object
	(properties
		name "SL"
		state $0000
		code 0
	)
	
	(method (doit &tmp temp0)
		(if code
			(= temp0 (Memory MNeedPtr 150))
			(code doit: temp0)
			(DrawStatus (if state temp0 else 0))
			(Memory MDisposePtr temp0)
		)
	)
	
	(method (enable)
		(= state 1)
		(self doit:)
	)
	
	(method (disable)
		(= state 0)
		(self doit:)
	)
)

(instance RestoreUpdate of Code
	(properties
		name "RU"
	)
	
	(method (doit param1 &tmp temp0)
		(if (param1 underBits?)
			(= temp0
				(&
					(= temp0 (| (= temp0 (param1 signal?)) $0001))
					$fffb
				)
			)
			(param1 underBits: 0 signal: temp0)
		)
	)
)

(instance DisposeNonKeptRegion of Code
	(properties
		name "DNKR"
	)
	
	(method (doit param1)
		(if (not (param1 keep?)) (param1 dispose:))
	)
)

(instance featureDisposeCode of Code
	(properties
		name "fDC"
	)
	
	(method (doit param1)
		(if (param1 respondsTo: #delete)
			(param1
				signal: (& (param1 signal?) $ffdf)
				dispose:
				delete:
			)
		else
			(param1 dispose:)
		)
	)
)
