;;; Sierra Script 1.0 - (do not remove this comment)
(script# 921)
(include game.sh)
(use Main)
(use Intrface)
(use Dialog)
(use System)

(public
	Prints 0
	Printf 1
	GetInput 2
	FindFormatLen 3
)

(procedure (Prints &tmp newPrint)
	(= newPrint (Print new:))
	(newPrint addText: &rest init:)
)

(procedure (Printf &tmp newPrint)
	(= newPrint (Print new:))
	(newPrint addTextF: &rest init:)
)

(procedure (GetInput param1 param2 param3 param4)
	(if
		((Print new:)
			font: (if (> argc 3) param4 else userFont)
			addText: (if (and (> argc 2) param3) param3 else {})
			addEdit: param1 param2 0 12 param1
			init:
		)
		(StrLen param1)
	)
)

(procedure (FindFormatLen param1 param2 &tmp temp0 temp1 temp2 temp3)
	(= temp0 (= temp1 (StrLen param1)))
	(= temp2 0)
	(= temp3 0)
	(while (< temp3 temp1)
		(if (== (StrAt param1 temp3) 37)
			(switch (StrAt param1 (++ temp3))
				(100 (= temp0 (+ temp0 5)))
				(120 (= temp0 (+ temp0 4)))
				(115
					(= temp0 (+ temp0 (StrLen [param2 temp2])))
				)
			)
			(++ temp2)
		)
		(++ temp3)
	)
	(return (++ temp0))
)

(class Print of Object
	(properties
		dialog 0
		window 0
		title 0
		mode 0
		font -1
		width 0
		x -1
		y -1
		ticks 0
		caller 0
		retValue 0
		modeless 0
		first 0
		saveCursor 0
	)
	
	(method (init theCaller)
		(= caller 0)
		(if argc (= caller theCaller))
		(if (> argc 1) (self addText: &rest))
		(if (not modeless)
			(if (not (IsObject prints))
				(= prints ((EventHandler new:) name: {prints}))
			)
			(prints add: self)
		)
		(self showSelf:)
	)
	
	(method (doit)
		(dialog eachElementDo: #doit)
	)
	
	(method (dispose)
		(if (and prints (prints contains: self))
			(prints delete: self)
			(if (prints isEmpty:) (prints dispose:) (= prints 0))
		)
		(if title (Memory memFREE title))
		(= width
			(= mode
				(= title (= first (= saveCursor (= window 0))))
			)
		)
		(= x (= y -1))
		(= modeless 0)
		(sounds pause: 0)
		(super dispose:)
	)
	
	(method (showSelf &tmp theFirst temp1 temp2 temp3 temp4)
		(if saveCursor (theGame setCursor: 999))
		(if (not dialog) (= dialog (Dialog new:)))
		(dialog
			window: (if window else systemWindow)
			name: {PODialog}
			caller: self
		)
		(dialog text: title time: ticks setSize:)
		(dialog center:)
		(= temp3 (if (== x -1) (dialog nsLeft?) else x))
		(= temp4 (if (== y -1) (dialog nsTop?) else y))
		(dialog moveTo: temp3 temp4)
		(= temp1 (GetPort))
		(dialog open: (if title 4 else 0) 15)
		(return
			(if modeless
				(= modelessPort (GetPort))
				(SetPort temp1)
				(= modelessDialog dialog)
			else
				(sounds pause: 1)
				(cond 
					((not (= theFirst first))
						(if
							(and
								(= theFirst (dialog firstTrue: #checkState 1))
								(not (dialog firstTrue: #checkState 2))
							)
							(theFirst state: (| (theFirst state?) $0002))
						)
					)
					((not (IsObject theFirst)) (= theFirst (dialog at: theFirst)))
				)
				(= retValue (dialog doit: theFirst))
				(SetPort temp1)
				(cond 
					((== retValue -1) (= retValue 0))
					(
					(and (IsObject retValue) (retValue isKindOf: DButton)) (= retValue (retValue value?)))
					((not (dialog theItem?)) (= retValue 1))
				)
				(if saveCursor
					(theGame setCursor: ((theIconBar curIcon?) cursor?))
				)
				(dialog dispose:)
				(return retValue)
			)
		)
	)
	
	(method (addButton param1 theTheCurRoomNum &tmp theTheTheCurRoomNum theTheTheCurRoomNum_2 theTheTheCurRoomNum_3 temp3 theTheTheCurRoomNum_4 theTheTheCurRoomNum_5 theCurRoomNum temp7 temp8)
		(if (not dialog) (= dialog (Dialog new:)))
		(if (== font -1) (= font userFont))
		(if (> argc 4)
			(= theTheTheCurRoomNum [theTheCurRoomNum 0])
			(= theTheTheCurRoomNum_2 [theTheCurRoomNum 1])
			(= theTheTheCurRoomNum_3 [theTheCurRoomNum 2])
			(= temp3
				(if [theTheCurRoomNum 3] [theTheCurRoomNum 3] else 1)
			)
			(= theTheTheCurRoomNum_4 0)
			(= theTheTheCurRoomNum_5 0)
			(= theCurRoomNum curRoomNum)
			(if (> argc 5)
				(= theTheTheCurRoomNum_4 [theTheCurRoomNum 4])
				(if (> argc 6)
					(= theTheTheCurRoomNum_5 [theTheCurRoomNum 5])
					(if (> argc 7) (= theCurRoomNum [theTheCurRoomNum 6]))
				)
			)
			(if
				(= temp8
					(Message
						msgSIZE
						theCurRoomNum
						theTheTheCurRoomNum
						theTheTheCurRoomNum_2
						theTheTheCurRoomNum_3
						temp3
					)
				)
				(= temp7 (Memory memALLOC_CRIT temp8))
				(if
					(not
						(Message
							msgGET
							theCurRoomNum
							theTheTheCurRoomNum
							theTheTheCurRoomNum_2
							theTheTheCurRoomNum_3
							temp3
							temp7
						)
					)
					(= temp7 0)
				)
			)
		else
			(= theTheTheCurRoomNum_4 0)
			(= theTheTheCurRoomNum_5 0)
			(if (> argc 2)
				(= theTheTheCurRoomNum_4 [theTheCurRoomNum 1])
				(if (> argc 3)
					(= theTheTheCurRoomNum_5 [theTheCurRoomNum 2])
				)
			)
			(= temp7
				(Memory
					memALLOC_CRIT
					(+ (StrLen [theTheCurRoomNum 0]) 1)
				)
			)
			(StrCpy temp7 [theTheCurRoomNum 0])
		)
		(if temp7
			(dialog
				add:
					((DButton new:)
						value: param1
						font: font
						text: temp7
						setSize:
						moveTo: (+ 4 theTheTheCurRoomNum_4) (+ 4 theTheTheCurRoomNum_5)
						yourself:
					)
				setSize:
			)
		)
	)
	
	(method (addEdit param1 param2 param3 param4 param5 &tmp temp0 temp1)
		(if (not dialog) (= dialog (Dialog new:)))
		(StrCpy param1 (if (> argc 4) param5 else {}))
		(if (> argc 2)
			(= temp0 param3)
			(if (> argc 3) (= temp1 param4))
		)
		(dialog
			add:
				((DEdit new:)
					text: param1
					max: param2
					setSize:
					moveTo: (+ temp0 4) (+ temp1 4)
					yourself:
				)
			setSize:
		)
	)
	
	(method (addIcon param1 param2 param3 param4 param5 &tmp temp0 temp1)
		(if (not dialog) (= dialog (Dialog new:)))
		(if (> argc 3)
			(= temp0 param4)
			(= temp1 param5)
		else
			(= temp0 (= temp1 0))
		)
		(if (IsObject param1)
			(dialog
				add: (param1
					setSize:
					moveTo: (+ temp0 4) (+ temp1 4)
					yourself:
				)
				setSize:
			)
		else
			(dialog
				add:
					((DIcon new:)
						view: param1
						loop: param2
						cel: param3
						setSize:
						moveTo: (+ temp0 4) (+ temp1 4)
						yourself:
					)
				setSize:
			)
		)
	)
	
	(method (addText theTheCurRoomNum &tmp theTheTheCurRoomNum theTheTheCurRoomNum_2 theTheTheCurRoomNum_3 temp3 theTheTheCurRoomNum_4 theTheTheCurRoomNum_5 theCurRoomNum temp7 temp8)
		(if (not dialog) (= dialog (Dialog new:)))
		(if (== font -1) (= font userFont))
		(if (> argc 3)
			(= theTheTheCurRoomNum [theTheCurRoomNum 0])
			(= theTheTheCurRoomNum_2 [theTheCurRoomNum 1])
			(= theTheTheCurRoomNum_3 [theTheCurRoomNum 2])
			(= temp3
				(if [theTheCurRoomNum 3] [theTheCurRoomNum 3] else 1)
			)
			(= theTheTheCurRoomNum_4 0)
			(= theTheTheCurRoomNum_5 0)
			(= theCurRoomNum curRoomNum)
			(if (>= argc 5)
				(= theTheTheCurRoomNum_4 [theTheCurRoomNum 4])
				(if (>= argc 6)
					(= theTheTheCurRoomNum_5 [theTheCurRoomNum 5])
					(if (>= argc 7) (= theCurRoomNum [theTheCurRoomNum 6]))
				)
			)
			(if
				(= temp8
					(Message
						msgSIZE
						theCurRoomNum
						theTheTheCurRoomNum
						theTheTheCurRoomNum_2
						theTheTheCurRoomNum_3
						temp3
					)
				)
				(= temp7 (Memory memALLOC_CRIT temp8))
				(if
					(Message
						msgGET
						theCurRoomNum
						theTheTheCurRoomNum
						theTheTheCurRoomNum_2
						theTheTheCurRoomNum_3
						temp3
						temp7
					)
					(dialog
						add:
							((DText new:)
								text: temp7
								font: font
								mode: mode
								setSize: width
								moveTo: (+ 4 theTheTheCurRoomNum_4) (+ 4 theTheTheCurRoomNum_5)
								yourself:
							)
						setSize:
					)
				)
			)
		else
			(= theTheTheCurRoomNum_4 0)
			(= theTheTheCurRoomNum_5 0)
			(if (>= argc 2)
				(= theTheTheCurRoomNum_4 [theTheCurRoomNum 1])
				(if (>= argc 3)
					(= theTheTheCurRoomNum_5 [theTheCurRoomNum 2])
				)
			)
			(= temp7
				(Memory
					memALLOC_CRIT
					(+ (StrLen [theTheCurRoomNum 0]) 1)
				)
			)
			(StrCpy temp7 [theTheCurRoomNum 0])
			(dialog
				add:
					((DText new:)
						text: temp7
						font: font
						mode: mode
						setSize: width
						moveTo: (+ 4 theTheTheCurRoomNum_4) (+ 4 theTheTheCurRoomNum_5)
						yourself:
					)
				setSize:
			)
		)
	)
	
	(method (addTextF &tmp temp0 temp1)
		(= temp0 (FindFormatLen &rest))
		(= temp1 (Memory memALLOC_CRIT temp0))
		(Format temp1 &rest)
		(self addText: temp1)
		(Memory memFREE temp1)
	)
	
	(method (addTitle param1 &tmp temp0 temp1 temp2 temp3 temp4 temp5)
		(if (> argc 1)
			(= temp0 [param1 0])
			(= temp1 [param1 1])
			(= temp2 [param1 2])
			(= temp3 [param1 3])
			(= temp4 [param1 4])
			(if
			(= temp5 (Message msgSIZE temp4 temp0 temp1 temp2 temp3))
				(= title (Memory memALLOC_CRIT temp5))
				(Message msgGET temp4 temp0 temp1 temp2 temp3 title)
			)
		else
			(= title
				(Memory memALLOC_CRIT (+ (StrLen [param1 0]) 1))
			)
			(StrCpy title [param1 0])
		)
	)
	
	(method (posn theX theY)
		(= x theX)
		(= y theY)
	)
	
	(method (handleEvent pEvent)
		(if (dialog handleEvent: pEvent) (dialog dispose:))
	)
	
	(method (cue &tmp theCaller)
		(= theCaller caller)
		(= dialog 0)
		(if window (window dispose:))
		(self dispose:)
		(if theCaller (theCaller cue:))
	)
)
