;;; Sierra Script 1.0 - (do not remove this comment)
(script# 929)
(include game.sh)
(use Main)
(use Timer)
(use Motion)
(use System)


(class Sync of Object
	(properties
		syncTime -1
		syncCue $ffff
		prevCue $ffff
		syncNum -1
	)
	
	(method (syncStart param1 param2 param3 param4 param5)
		(DoSync 0 self param1 param2 param3 param4 param5)
		(if (!= syncCue -1) (= prevCue syncCue) (= syncTime 0))
	)
	
	(method (syncCheck)
		(if
			(and
				(!= syncCue -1)
				(or (u<= syncTime syncBias) (<= syncTime (DoAudio 6)))
			)
			(if (== (& $fff0 syncCue) 0)
				(= prevCue (| (& prevCue $fff0) syncCue))
			else
				(= prevCue syncCue)
			)
			(DoSync 1 self)
		)
	)
	
	(method (syncStop)
		(= prevCue -1)
		(DoSync 2)
	)
)

(class ScriptSync of Object
	(properties
		prevSignal -1
		playing 0
	)
	
	(method (init param1 param2 param3 param4 param5)
		(if theSync (self cue:))
		((= theSync (Sync new:))
			init:
			syncStart: param1 param2 param3 param4 param5
		)
		(if (!= (theSync prevCue?) -1)
			(= playing 1)
			(regions add: self)
		)
		(Timer
			setTicks: self (DoAudio 1 param1 param2 param3 param4 param5)
		)
	)
	
	(method (doit &tmp theSyncSyncTime)
		(if (!= (theSync prevCue?) -1)
			(repeat
				(if (== (theSync prevCue?) -1) (break))
				(= theSyncSyncTime (theSync syncTime?))
				(theSync syncCheck:)
				(if (== theSyncSyncTime (theSync syncTime?)) (break))
			)
			(= prevSignal (theSync prevCue?))
		)
	)
	
	(method (cue)
		(Animate (cast elements?) 0)
		(= playing 0)
		(= prevSignal 32767)
		(regions delete: self)
		(if theSync (theSync syncStop: dispose:) (= theSync 0))
	)
)

(class MouthSync of Cycle
	(properties
		client 0
		caller 0
		cycleDir 1
		cycleCnt 0
		completed 0
	)
	
	(method (init param1 param2 param3 param4 param5 param6)
		(super init: param1)
		(if (IsObject theSync) (theSync syncStop: dispose:))
		((= theSync (Sync new:))
			syncStart: param2 param3 param4 param5 param6
		)
	)
	
	(method (doit &tmp temp0 theSyncSyncTime_2 theSyncSyncTime temp3)
		(super doit:)
		(if (!= (theSync prevCue?) -1)
			(= theSyncSyncTime (theSync syncTime?))
			(= temp3 0)
			(repeat
				(= theSyncSyncTime_2 (theSync syncTime?))
				(theSync syncCheck:)
				(if (== theSyncSyncTime_2 (theSync syncTime?)) (break))
			)
			(if
				(and
					(!= theSyncSyncTime (theSync syncTime?))
					(!=
						(client cel?)
						(= temp0 (& $000f (theSync prevCue?)))
					)
				)
				(client cel: temp0)
			)
		else
			(= completed 1)
			(self cycleDone:)
		)
	)
	
	(method (dispose)
		(super dispose:)
		(if theSync (theSync dispose:) (= theSync 0))
	)
	
	(method (cue)
		(if theSync
			(theSync syncStop: dispose:)
			(= theSync 0)
			(if caller (caller cue:) (= caller 0))
		)
	)
)
