;;; Sierra Script 1.0 - (do not remove this comment)
(script# 996)
(include game.sh)
(use Main)
(use System)


(instance uEvt of Event
	(properties)
	
	(method (new)
		(= type
			(= message
				(= modifiers (= y (= x (= claimed (= port 0)))))
			)
		)
		(GetEvent 32767 self)
		(return self)
	)
)

(class User of Object
	(properties
		alterEgo 0
		input 0
		controls 0
		prevDir 0
		x -1
		y -1
		mapKeyToDir 1
		curEvent 0
	)
	
	(method (init)
		(= curEvent uEvt)
	)
	
	(method (doit)
		(curEvent new:)
		(self handleEvent: curEvent)
	)
	
	(method (canControl theControls)
		(if argc (= controls theControls) (= prevDir 0))
		(return controls)
	)
	
	(method (handleEvent pEvent &tmp pEventType pEventMessage pEventModifiers temp3 temp4)
		(= mouseX (pEvent x?))
		(= mouseY (pEvent y?))
		(= pEventType (pEvent type?))
		(= pEventModifiers (pEvent modifiers?))
		(if pEventType
			(= lastEvent pEvent)
			(if mapKeyToDir (MapKeyToDir pEvent))
			(if (== pEventType evJOYDOWN)
				(= pEventType 4)
				(= pEventMessage
					(if (& pEventModifiers emSHIFT) 27 else 13)
				)
				(= pEventModifiers 0)
				(pEvent
					type: pEventType
					message: pEventMessage
					modifiers: pEventModifiers
				)
			)
			(if
			(and speechHandler (speechHandler handleEvent: pEvent))
				(return 1)
			)
			(if (and prints (prints handleEvent: pEvent))
				(return 1)
			)
			(pEvent localize:)
			(= pEventType (pEvent type?))
			(= pEventMessage (pEvent message?))
			(cond 
				((& pEventType evSAID)
					(cond 
						(
							(and
								(== pEventMessage JOY_UP)
								(or
									(= temp4 (cast firstTrue: #perform findNoun))
									(= temp4 (features firstTrue: #perform findNoun))
									(= temp4 (addToPics firstTrue: #perform findNoun))
								)
							)
							(temp4 doVerb: ((theIconBar curIcon?) message?))
						)
						((= temp4 (theIconBar findIcon: pEventMessage))
							(theIconBar select: temp4)
							(theGame setCursor: (temp4 cursor?))
						)
					)
				)
				((& pEventType evJOYSTICK)
					(cond 
						(
							(and
								directionHandler
								(directionHandler handleEvent: pEvent)
							)
							(return 1)
						)
						(
							(and
								(or
									(and
										theIconBar
										(== (theIconBar curIcon?) (theIconBar walkIconItem?))
									)
									(not theIconBar)
								)
								alterEgo
								controls
								(cast contains: alterEgo)
								(alterEgo handleEvent: pEvent)
							)
							(return 1)
						)
						(
							(and
								pMouse
								(or
									(not (& pEventType evKEYBOARD))
									(!= pEventMessage JOY_NULL)
								)
								(pMouse handleEvent: pEvent)
							)
							(return 1)
						)
					)
				)
				(
					(and
						(& pEventType evKEYBOARD)
						keyDownHandler
						(keyDownHandler handleEvent: pEvent)
					)
					(return 1)
				)
				(
					(and
						(& pEventType evMOUSE)
						mouseDownHandler
						(mouseDownHandler handleEvent: pEvent)
					)
					(return 1)
				)
			)
		)
		(if theIconBar (theIconBar handleEvent: pEvent))
		(if (pEvent claimed?) (return 1))
		(= pEventType (pEvent type?))
		(= pEventMessage (pEvent message?))
		(if (and input (& pEventType evVERB))
			(cond 
				(
					(and
						(& pEventType evMOVE)
						walkHandler
						(walkHandler handleEvent: pEvent)
					)
					(return 1)
				)
				(
					(and
						(& pEventType evMOVE)
						(cast contains: alterEgo)
						controls
						(alterEgo handleEvent: pEvent)
					)
					(return 1)
				)
				(useSortedFeatures
					(OnMeAndLowY init:)
					(cast eachElementDo: #perform OnMeAndLowY pEvent)
					(features eachElementDo: #perform OnMeAndLowY pEvent)
					(addToPics eachElementDo: #perform OnMeAndLowY pEvent)
					(if
						(and
							(OnMeAndLowY theObj?)
							((OnMeAndLowY theObj?) handleEvent: pEvent)
						)
						(return 1)
					)
				)
				((cast handleEvent: pEvent) (return 1))
				((features handleEvent: pEvent) (return 1))
				((addToPics handleEvent: pEvent) (return 1))
			)
			(if
				(and
					(not (pEvent claimed?))
					(regions handleEvent: pEvent)
				)
				(return 1)
			)
		)
		(if pEventType
			(cond 
				((theGame handleEvent: pEvent) (return 1))
				((and prints (prints handleEvent: pEvent)) (return 1))
			)
		)
		(return 0)
	)
	
	(method (canInput theInput)
		(if argc (= input theInput))
		(return input)
	)
)

(class OnMeAndLowY of Code
	(properties
		theObj 0
		lastY -1
	)
	
	(method (init)
		(= theObj 0)
		(= lastY -1)
	)
	
	(method (doit theTheObj param2)
		(if
		(and (theTheObj onMe: param2) (> (theTheObj y?) lastY))
			(= lastY ((= theObj theTheObj) y?))
		)
	)
)

(instance findNoun of Code
	(properties)
	
	(method (doit param1 param2)
		(return (== (param1 noun?) param2))
	)
)
