;;; Sierra Script 1.0 - (do not remove this comment)
(script# 210)
(include game.sh)
(use Main)
(use InnRoom)
(use Print)
(use Motion)
(use Actor)
(use System)

(public
	chess 0
)

(instance chess of InnRoom
	(properties
		picture 210
		nextRoom 180
		prevRoom 170
	)
	
	(method (init)
		(bishop init:)
		(theClock init:)
		(super init: &rest)
		(self setScript: sChess)
	)
)

(instance sChess of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 3))
			(1
				(Print
					width: 290
					posn: -1 180
					addText:
						{You can also play with people of different experience levels.
						Imagine learning from real-live people, or maybe even teaching
						somebody less experienced then yourself.}
					modeless: 1
					init:
				)
				(= seconds 6)
			)
			(2
				(SFX number: 102 play:)
				(bishop moveSpeed: 2 setMotion: MoveTo 172 117 self)
			)
			(3 (= seconds 4))
			(4
				(if modelessDialog (modelessDialog dispose:))
				(curRoom newRoom: (curRoom nextRoom:))
			)
		)
	)
)

(instance bishop of Actor
	(properties
		x 72
		y 37
		view 210
	)
)

(instance theClock of Actor
	(properties
		x 300
		y 83
		view 210
		loop 1
	)
	
	(method (init)
		(super init: &rest)
		(self setPri: 15 setScript: clockScript)
	)
)

(instance clockScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 1))
			(1
				(if (== (client cel?) (client lastCel:))
					(self dispose:)
				else
					(client cel: (+ (client cel?) 1))
					(self init:)
				)
			)
		)
	)
)
