;;; Sierra Script 1.0 - (do not remove this comment)
(script# 110)
(include game.sh)
(use Main)
(use InnRoom)
(use Print)
(use Motion)
(use Actor)
(use System)

(public
	map 0
)

(instance map of InnRoom
	(properties
		picture 110
		nextRoom 120
		prevRoom 100
	)
	
	(method (init)
		(super init: &rest)
		(self setScript: sMap)
	)
)

(instance sMap of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(casinoSign init:)
				(lights1 init:)
				(lights2 init:)
				(lights3 init:)
				(water init:)
				(windmill init:)
				(smoke init:)
				(plane init:)
				(postOfficeFlag init:)
				(= cycles 2)
			)
			(1 (= seconds 3))
			(2
				(Print
					width: 290
					posn: -1 180
					addText:
						{Welcome to ImagiNation, the premier, on-line interactive entertainment network.
						ImagiNation is the place to escape for fun, fantasy, and friendship.}
					modeless: 1
					init:
				)
				(= seconds 10)
			)
			(3
				(if modelessDialog (modelessDialog dispose:))
				(Print
					width: 290
					posn: -1 180
					addText:
						{The demonstration you are about to see will show you why you should join INN today!
						Just think, your hard-working PC that runs word processors and spreadsheets can also
						open up a whole new world of excitement. The world of ImagiNation!}
					modeless: 1
					init:
				)
				(= seconds 15)
			)
			(4
				(if modelessDialog (modelessDialog dispose:))
				(curRoom newRoom: (curRoom nextRoom:))
			)
		)
	)
)

(instance water of Prop
	(properties
		x 135
		y 104
		view 110
	)
	
	(method (init)
		(super init:)
		(self cycleSpeed: (Random 10 12) setCycle: Forward)
	)
)

(instance casinoSign of Prop
	(properties
		x 128
		y 10
		view 110
		loop 1
	)
	
	(method (init)
		(super init:)
		(self cycleSpeed: (Random 12 15) setCycle: Forward)
	)
)

(instance smoke of Prop
	(properties
		x 236
		y 12
		view 110
		loop 2
	)
	
	(method (init)
		(super init:)
		(self cycleSpeed: (Random 13 15) setCycle: Forward)
	)
)

(instance windmill of Prop
	(properties
		x 291
		y 70
		view 110
		loop 3
	)
	
	(method (init)
		(super init:)
		(self cycleSpeed: (Random 10 12) setCycle: Forward)
	)
)

(instance lights1 of Prop
	(properties
		x 85
		y 7
		view 110
		loop 4
	)
	
	(method (init)
		(super init:)
		(self cycleSpeed: (Random 10 12) setCycle: Forward)
	)
)

(instance lights2 of Prop
	(properties
		x 50
		y 31
		view 110
		loop 5
	)
	
	(method (init)
		(super init:)
		(self cycleSpeed: (Random 10 12) setCycle: Forward)
	)
)

(instance lights3 of Prop
	(properties
		x 102
		y 12
		view 110
		loop 6
	)
	
	(method (init)
		(super init:)
		(self cycleSpeed: (Random 10 12) setCycle: Forward)
	)
)

(instance plane of Prop
	(properties
		x 177
		y 46
		view 110
		loop 7
	)
)

(instance postOfficeFlag of Prop
	(properties
		x 79
		y 69
		view 110
		loop 8
	)
	
	(method (init)
		(super init:)
		(self cycleSpeed: (Random 14 16) setCycle: Forward)
	)
)
