;;; Sierra Script 1.0 - (do not remove this comment)
(script# 100)
(include game.sh)
(use Main)
(use InnRoom)
(use Print)
(use Motion)
(use Actor)
(use System)

(public
	titleRm 0
)

(instance titleRm of InnRoom
	(properties
		picture 100
		style PIXELDISSOLVE
		nextRoom 110
	)
	
	(method (init)
		(super init: &rest)
		(Display 100 0 p_font 800 p_at 62 125 p_color 223)
		(Display 100 0 p_font 800 p_at 60 121 p_color 165)
		(self setScript: sTitle)
	)
)

(instance sTitle of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 2))
			(1
				(if debugging
					(switch
						(Print
							addText: {Teleport to:}
							addButton: 1 {BARON} 5 20
							addButton: 2 {BJACK} 5 40
							addButton: 5 {BRIDGE} 5 100
							addButton: 9 {GOLF} 80 20
							addButton: 16 {Continue} 80 160
							addButton: 3 {BOARDS} 5 60
							addButton: 4 {BOOGERS} 5 80
							addButton: 6 {CHESS} 5 120
							addButton: 10 {MAP} 80 40
							addButton: 11 {STRATEGO} 80 60
							addButton: 12 {TITLE} 80 80
							addButton: 13 {TITLE2} 80 100
							addButton: 14 {TRIVIA} 80 120
							addButton: 15 {WAITROOM} 80 140
							init:
						)
						(1 (curRoom newRoom: 130))
						(2 (curRoom newRoom: 180))
						(3 (curRoom newRoom: 190))
						(4 (curRoom newRoom: 120))
						(5 (curRoom newRoom: 200))
						(6 (curRoom newRoom: 210))
						(7 (curRoom newRoom: 0))
						(8 (curRoom newRoom: 1))
						(9 (curRoom newRoom: 140))
						(10 (curRoom newRoom: 110))
						(11 (curRoom newRoom: 220))
						(12 (curRoom newRoom: 100))
						(13 (curRoom newRoom: 230))
						(14 (curRoom newRoom: 170))
						(15 (curRoom newRoom: 160))
						(16 (= seconds 3))
					)
				else
					(SetCursor 0)
					(= seconds 3)
				)
				(ambience
					number: (if (== (DoSound NumVoices) 32) 960 else 961)
					play:
				)
			)
			(2
				(yellowSparkle init:)
				(= seconds 2)
			)
			(3
				(greenSparkle init:)
				(= seconds 2)
			)
			(4
				(curRoom drawPic: (curRoom picture?) 9)
				(= cycles 10)
			)
			(5
				(curRoom newRoom: (curRoom nextRoom:))
			)
		)
	)
)

(instance yellowSparkle of Prop
	(properties
		x 154
		y 76
		view 0
		loop 1
		cycleSpeed 8
	)
	
	(method (init)
		(super init:)
		(self setCycle: EndLoop)
	)
)

(instance greenSparkle of Prop
	(properties
		x 230
		y 55
		view 0
		loop 2
	)
	
	(method (init)
		(super init:)
		(self setCycle: EndLoop)
	)
)
