;;; Sierra Script 1.0 - (do not remove this comment)
(script# 160)
(include game.sh)
(use Main)
(use InnRoom)
(use Print)
(use Motion)
(use Actor)
(use System)

(public
	waitRoom 0
)

(local
	local0 =  161
	local1 =  22
)
(instance waitRoom of InnRoom
	(properties
		picture 160
		nextRoom 190
		prevRoom 220
	)
	
	(method (init)
		(dGuy init:)
		(pointer init:)
		(super init: &rest)
		(self setScript: sWaitRoom)
	)
)

(instance sWaitRoom of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 2))
			(1
				(Print
					posn: -1 180
					modeless: 1
					width: 290
					addText:
						{With a simple click of a mouse, your circle of friends will suddenly expand
						to include potentially tens of thousands of people from all over the country.}
					posn: 10 200
					init:
				)
				(= seconds 8)
			)
			(2
				(if modelessDialog (modelessDialog dispose:))
				(pointer moveSpeed: 1 setMotion: MoveTo 136 55 self)
			)
			(3 (= cycles 10))
			(4
				(dGuy dispose:)
				(= cycles 10)
			)
			(5 (talk init:) (= seconds 2))
			(6
				(self setScript: doDisplays self)
			)
			(7
				(talk dispose:)
				(= seconds 2)
			)
			(8
				(Print
					posn: -1 180
					modeless: 1
					width: 290
					addText:
						{You'll be able to share your thoughts with hundreds of live chat areas and bulletin boards.}
					posn: 10 200
					init:
				)
				(= seconds 8)
			)
			(9
				(if modelessDialog (modelessDialog dispose:))
				(= cycles 10)
			)
			(10
				(curRoom newRoom: (curRoom nextRoom:))
			)
		)
	)
)

(instance doDisplays of Script
	(properties)
	
	(method (changeState newState)
		(SFX number: 3003 play:)
		(switch (= state newState)
			(0
				(Display {S}
					p_at local1 local0
					p_color 255
					p_font 1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(1
				(Display {o}
					p_at local1 local0
					p_color 255
					p_font 1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(2
				(Display {,}
					p_at local1 local0
					p_color 255
					p_font 1006
				)
				(= local1 (+ local1 3))
				(= cycles 70)
			)
			(3
				(Display {_}
					p_at local1 local0
					p_color 255
					p_font 1006
				)
				(= local1 (+ local1 6))
				(= cycles 40)
			)
			(4
				(Display {w}
					p_at local1 local0
					p_color 255
					p_font 1006
				)
				(= local1 (+ local1 7))
				(= cycles 70)
			)
			(5
				(Display
					{h}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(6
				(Display
					{a}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(7
				(Display
					{t}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(8
				(Display
					{_}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(9
				(Display
					{d}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 6))
				(= cycles 70)
			)
			(10
				(Display
					{i}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 3))
				(= cycles 70)
			)
			(11
				(Display
					{d}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(12
				(Display
					{_}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(13
				(Display
					{y}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(14
				(Display
					{o}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(15
				(Display
					{u}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(16
				(Display
					{_}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(17
				(Display
					{t}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(18
				(Display
					{h}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(19
				(Display
					{i}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 3))
				(= cycles 40)
			)
			(20
				(Display
					{n}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(21
				(Display
					{k}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(22
				(Display
					{_}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(23
				(Display
					{o}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(24
				(Display
					{f}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(25
				(Display
					{_}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(26
				(Display
					{t}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(27
				(Display
					{h}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(28
				(Display
					{e}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(29
				(Display
					{_}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(30
				(Display
					{g}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(31
				(Display
					{a}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(32
				(Display
					{m}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 6))
				(= cycles 70)
			)
			(33
				(Display
					{e}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(34
				(Display
					{_}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(35
				(Display
					{l}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 3))
				(= cycles 70)
			)
			(36
				(Display
					{a}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(37
				(Display
					{s}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(38
				(Display
					{t}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(39
				(Display
					{_}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(40
				(Display
					{n}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(41
				(Display
					{i}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 3))
				(= cycles 40)
			)
			(42
				(Display
					{g}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 70)
			)
			(43
				(Display
					{h}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(44
				(Display
					{t}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= cycles 40)
			)
			(45
				(Display
					{?}
					p_at
					local1
					local0
					p_color
					255
					p_font
					1006
				)
				(= local1 (+ local1 5))
				(= seconds 3)
			)
			(46 (self dispose:))
		)
	)
)

(instance dGuy of Prop
	(properties
		x 86
		y 44
		view 160
	)
)

(instance pointer of Actor
	(properties
		x 300
		y 100
		view 999
		loop 1
	)
)

(instance talk of View
	(properties
		x 10
		y 152
		view 160
		loop 1
	)
)
